/// \file mil1553ud_ioctl.h
/// \brief инфраструктура для обработки ioctl команд
#ifndef MIL1553UD_IOCTL_H
#define MIL1553UD_IOCTL_H

#include <linux/cdev.h>
#include <linux/device.h>
#include <linux/kernel.h>
#include <linux/slab.h>
#include <linux/uaccess.h>
#include <linux/fs.h>
#include <linux/ioctl.h>
#include <linux/pci.h>
#include <linux/cdev.h>

#include "mil1553ud_cdev.h"
#include "mil1553ud_cmd.h"

/// \brief ioctl_handler обработчик ioctl-команд
/// \param dev указатель на сивольное устройство
/// \param cmd команда
/// \param arg аргументы команды
/// \return результат операции
long ioctl_handler(struct mil1553_cdev_data* dev, unsigned int cmd, unsigned long arg);

/// \brief выбор регистра в соотв. с номером канала
#define CHOOSE_CHANNEL_REG(numCh, ch1, ch2, ch3, ch4)     \
    ((numCh == CH_NUM_1) ? ch1 : ((numCh == CH_NUM_2) ? ch2 : ((numCh == CH_NUM_3) ? ch3 : ch4)))

#endif // MIL1553UD_IOCTL_H
